﻿using BepInEx;
using BepInEx.Configuration;
using HarmonyLib;
using RoR2.CameraModes;
using System.Reflection;
using System.Security.Permissions;
using Zoom = EntityStates.Railgunner.Scope.BaseScopeState;

[assembly: AssemblyVersion(Local.Scope.Sensitivity.Plugin.versionNumber)]
[assembly: SecurityPermission(SecurityAction.RequestMinimum, SkipVerification = true)]
		// Allow private member access via publicized assemblies.

namespace Local.Scope.Sensitivity
{
	[BepInPlugin("local.scope.sensitivity", "ScopeSensitivity", versionNumber)]
	public class Plugin : BaseUnityPlugin
	{
		public const string versionNumber = "0.1.0";

		private static float modifier = none;
		private static float sensitivity = none;

		private const float none = 1.0f;

		public void Awake()
		{
			sensitivity = Config.Bind(
					section: "General",
					key: "Scope Sensitivity",
					defaultValue: 66.67f,
					new ConfigDescription(
						"Adjust this percentage to increase or lower the mouse sensitivity "
							+ "when zoomed in with Railgunner's short/long-range scopes.",
						new AcceptableValueRange<float>(0, 200))
				).Value / 100;

			Harmony.CreateAndPatchAll(typeof(Plugin));
		}

		[HarmonyPatch(typeof(Zoom), nameof(Zoom.OnEnter))]
		[HarmonyPostfix]
		private static void ScopeIn() => modifier = sensitivity;

		[HarmonyPatch(typeof(Zoom), nameof(Zoom.OnExit))]
		[HarmonyPrefix]
		private static void ScopeOut() => modifier = none;

		[HarmonyPatch(typeof(CameraModeBase), nameof(CameraModeBase.CollectLookInput))]
		[HarmonyPostfix]
		private static void AdjustSensitivity(ref CameraModeBase.CollectLookInputResult result)
				=> result.lookInput *= modifier;
	}
}
